import os

import pymysql
from dbutils.persistent_db import PersistentDB
from pymysql.cursors import DictCursor

# from werkzeug import local


class DB():
    # NOTE dev/test env: short-lived connection
    # NOTE prod env: long-lived connection
    _db = None

    def init_db(self, host, port, username, password, database, charset):
        if os.environ.get('FLASK_ENV') == 'production':
            closeable = False
        else:
            closeable = True
        self._db = PersistentDB(
            creator=pymysql,
            # threadlocal=local.Local,
            host=host,
            user=username,
            password=password,
            database=database,
            port=port,
            charset=charset,
            cursorclass=DictCursor,
            closeable=closeable,
            autocommit=True
        )

    def _get_connection(self):
        return self._db.connection()

    def get_connection(self):
        return self._db.connection()

    def get_steady_connection(self):
        return self._db.steady_connection()


_dict_db = {}


def get_db(name):
    db = _dict_db.get(name)
    if db:
        return db
    else:
        db = DB()
        db.init_db()


# TODO update production env
config_mysql = {
    'host': '',
    'port': '',
    'database': '',
    'username': '',
    'password': '',
    'charset': ''
}
db = DB()
db.init_db(**config_mysql)
